﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using System.Collections;
using System.Xml;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace StartPageNews
{
    /// <summary>
    /// Window1.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class Window1 : Window
    {
        int NewsNum; //소식인덱스담는변수
        int codenum;  //지역별코드
        
        ArrayList Contens = new ArrayList();  //뉴스제목을 담는 ArrayList
        ArrayList ListInfo = new ArrayList(); //뉴스 리스트를 담는 ArrayList
        String[] News = { "1", "2" };  //소식종류코드
        String[] Area = { "1000", "2000", "3000", "4000", "5000", "6000", "7000", "8000", "9000" };  //지역별 코드
        
        String subject;

        public Window1()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)  //초기 셋팅
        {
            NewsCombo.Items.Add("내고장소식");
            NewsCombo.Items.Add("정보화마을소식");

            AreaCombo.Items.Add("서울/인천/경기");
            AreaCombo.Items.Add("강원");
            AreaCombo.Items.Add("충북");
            AreaCombo.Items.Add("대전/충남");
            AreaCombo.Items.Add("전북");
            AreaCombo.Items.Add("광주/전남");
            AreaCombo.Items.Add("대구/경북");
            AreaCombo.Items.Add("부산/울산/경남");
            AreaCombo.Items.Add("제주");

            RangeCombo.Items.Add("5");
            RangeCombo.Items.Add("10");
            RangeCombo.Items.Add("15");

            RangeCombo.Text = "5";
            NewsCombo.Text = "내고장소식";
            AreaCombo.Text = "서울/인천/경기";
        }

        public BitmapImage LoadImage(string url)   //ImageURL 주소를 비트맵IMAGE로 바꿔주는 함수
        {
            try
            {
                if (string.IsNullOrEmpty(url))
                    return null;

                WebClient wc = new WebClient();
                Byte[] MyData = wc.DownloadData(url);
                wc.Dispose();
                BitmapImage bimgTemp = new BitmapImage();
                bimgTemp.BeginInit();
                bimgTemp.StreamSource = new MemoryStream(MyData);
                bimgTemp.EndInit();
                return bimgTemp;
            }
            catch
            {
                return null;
            }
        }

        private void NewsCombo_SelectionChanged(object sender, SelectionChangedEventArgs e) //뉴스항목을 선택했을 때.
        {
            ComboBox currentComboBox = sender as ComboBox;
            if (currentComboBox != null)
            {
                NewsNum = currentComboBox.SelectedIndex;
            }
        }

        private void AreaCombo_SelectionChanged(object sender, SelectionChangedEventArgs e) //지역을 선택했을 때
        {
            ComboBox currentComboBox = sender as ComboBox;
            XmlDocument doc = new XmlDocument();
            if (currentComboBox != null)
            {
                codenum = currentComboBox.SelectedIndex;
                doc.Load(String.Format("http://openapi.okdab.com/news/newsxml.jsp?key=c83ca4580ed2eb6989a520412d63145a&newskind={0}&code={1}&snum=1&enum={2}",
                    News[NewsNum], Area[codenum],RangeCombo.Text));
                // 요청URL(뉴스항목코드,지역코드, 범위 요청변수를 삽입)을 Load시킴   
            }
            String contentnum;
            int index;

            XmlNode currentNode = doc.SelectSingleNode("news");
            index = currentNode.SelectNodes("result").Count;

            SubJectList.Items.Clear();
            Contens.Clear();

            for (int i = 0; i < index; i++)
            {
                XmlNode result = currentNode.SelectNodes("result")[i];
                contentnum = result.SelectSingleNode("contentnum").InnerText;
                Contens.Add(contentnum);
                subject = result.SelectSingleNode("subject").InnerText;
                SubJectList.Items.Add(subject);
            }
            SubJectList.SelectedIndex = 0;    //뉴스제목 comboBox의 기본값을 인덱스 0으로 초기화 시켜줌
        }

        private void SubJectList_SelectionChanged(object sender, SelectionChangedEventArgs e) //뉴스제목을 선택했을 때
        {
            if (SubJectList.SelectedIndex == -1)  //제목리스트 index가 -1이 들어올 경우
            {
                SubJectList.Items.Add(subject);
                SubJectList.Items.Clear();    
                return;
            }

            richTextBox1.SelectAll();
            Clipboard.Clear();
            int list = SubJectList.SelectedIndex;
            
            XmlDocument doc = new XmlDocument();
            doc.Load(String.Format("http://openapi.okdab.com/news/newsxml_content.jsp?key=c83ca4580ed2eb6989a520412d63145a&newskind={0}&contentnum={1}", 
                News[NewsNum], Contens[list]));
            // 요청URL(뉴스항목코드,제목코드 요청변수를 삽입)을 Load시킴
           
            String count;
            String content, contentnum, contentDate, journalist;
            int index;

            XmlNode currentNode = doc.SelectSingleNode("news");
            index = currentNode.SelectNodes("result").Count;

            count = currentNode.SelectSingleNode("count").InnerText;


            string[] Imgurl;                    //Image url 주소
            string[] url = new string[30];      //image url 주소
            string[] Erase;                     //불필요한 부분들을,삭제할 것을 담을 배열

            for (int i = 0; i < index; i++)
            {
                XmlNode result = currentNode.SelectNodes("result")[i];
                contentnum = result.SelectSingleNode("contentnum").InnerText;
                content = result.SelectSingleNode("content").InnerText;

                content = Regex.Replace(content, "<br>", "\n");   //<br>삭제
                content = Regex.Replace(content, "<IMG alt=" + '"' + '"', string.Empty); //<IMG ㅡ> 삭제
                content = Regex.Replace(content, "src=" + '"', string.Empty);  //src="" 삭제

                Imgurl = content.Split(new string[] { "http", "jpg" }, StringSplitOptions.None); 
                //http ~ .jpg 문자열을 잡음
                Erase = content.Split(new string[] { "DIV", "}" }, StringSplitOptions.None);
                //DIV~ } 문자열을 잡음
                String aaa;
                if (Imgurl.Length == 1)  //Imgurl 길이가 1일때
                {
                    if (Erase.Length == 1)  //Erase 길이가 1일 때
                    {
                        Clipboard.Clear();
                        Clipboard.SetText(content); //클립보드에 뉴스본문
                        richTextBox1.Paste();  //RichTextBox에 복사
                    }
                    else
                    {
                        aaa = Erase[Erase.Length - 1];
                        Clipboard.Clear();
                        Clipboard.SetText(aaa);
                        richTextBox1.Paste();
                    }
                }

                else
                {
                    try
                    {
                        for (int j = 1; j < Imgurl.Length; j += 2)
                        {
                            url[j] = string.Format("{0}{1}{2}", "http", Imgurl[j], "jpg");
                            Clipboard.Clear();
                            Clipboard.SetText(Imgurl[j - 1] + "\n");
                            richTextBox1.Paste();
                            Clipboard.SetImage(LoadImage(url[j]));
                            richTextBox1.Paste();
                            content = Regex.Replace(content, url[j], string.Empty);
                        }
                    }
                    catch { return; }
                }

                contentDate = result.SelectSingleNode("contentDate").InnerText;
                journalist = result.SelectSingleNode("journalist").InnerText;

                Title.Content = SubJectList.Items[list].ToString() + " (기사날짜 : " + contentDate + ")";
                label7.Content = journalist + " 기자";
            }
        }
    }
}
